# creates a graphml file from csv file written by the R routine
# "bubblepreprocessor".

import networkx as nx
import matplotlib.pyplot as plt
import pandas as pd
import numpy as np
import copy

# directory with input files
idir = "/Supplement/"
# directory where .graphml files should be written
odir = "/Supplement/"
# choose semimetric "d0" or "d1"
deriv = "d1"

# choose inpit file
infil<-"temperature_changes_BI_DJF"
#infil<-"precipitation_changes_EA_JJA"


ifile = infil + "_" + deriv + ".csv"  
csvin = idir + ifile ##me_d1_pr_jja.csv"

G=nx.MultiGraph()

me = pd.read_csv(csvin, header = 0, sep = ";")
dim = len(me)
modelnames = list(me.columns.values)

for i in xrange(dim):
    gcmname = modelnames[i].split("_")[1]
    rcmname = modelnames[i].split("_")[0]
    if rcmname == "dGCM":
        rcmname = ""
        isgcm = "TRUE"
        isgcmnum = 1
        lab = copy.deepcopy(gcmname)
    else:
        isgcm = "FALSE"
        isgcmnum = 0
        lab = copy.deepcopy(rcmname)
    G.add_node(i, label=lab, gcmname=gcmname, rcmname=rcmname, isgcm = isgcm, isgcmnum = isgcmnum)

edges = []
edgeweights = []
for i in xrange(dim):
    for j in xrange(i, dim-1):
        edgeweight = float(me.iloc[i, j+1])
        G.add_edge(i, j+1, weight = edgeweight)

ofile = odir + infil +"_" + deriv + ".graphml"
nx.write_graphml(G,ofile)  
